with Bit_Ops;
package body Hash_Function is

  Nat_Max_Hash : constant Nat_Hash := Max_Hash;

  -- For immediate computation
  function Hash (Str : in String) return Hash_Range is
    Buffer : Hash_Buffer;
  begin
    Buffer.Add (Str);
    return Buffer.Get;
  end Hash;

  -- For iterative compuations:
  -- Reset computing of hash value
  procedure Rst (Buffer : in out Hash_Buffer) is
  begin
    Buffer.Value := 0;
  end Rst;

  -- Add Str to computed hash value
  procedure Add (Buffer : in out Hash_Buffer; Str : in String) is
    use Bit_Ops;
  begin
    for C of Str loop
      Buffer.Value := (Shl (Buffer.Value, 5) --## rule line off Parentheses
                       + Buffer.Value
                       + Character'Pos (C)) and Nat_Max_Hash;
    end loop;

  end Add;

  -- Get currently computed hash value (which is not reset)
  function Get (Buffer : in Hash_Buffer) return Hash_Range is
    (Hash_Range (Buffer.Value));

end Hash_Function;

